function [V, lambda] = eig (KP, A)
  ## XXX: This implementation provides a different permutation of eigenvalues and
  ## eigenvectors compared to 'eig (full (KP))'
  if (nargin == 1)
    ## Compute the eigenvalues and/or eigenvectors of a matrix
    if (nargout <= 1)
      ## Only eigenvalues were requested
      lambda_A = eig (KP.A);
      lambda_B = eig (KP.B);
      V = kronprod (lambda_A, lambda_B);
    elseif (nargout == 2)
      ## Both eigenvectors and eigen values were requested
      [V_A, lambda_A] = eig (KP.A);
      [V_B, lambda_B] = eig (KP.B);
      V = kronprod (V_A, V_B);
      lambda = kronprod (lambda_A, lambda_B);
    else
      print_usage ();
    endif
  elseif (nargin == 2)
    ## Solve generalised eigenvalue problem
    ## XXX: Is there a fancy way of doing this?
    [V, lambda] = eig (full (KP), full (A));
  else
    print_usage ();
  endif
endfunction
