function retval = inv (KP)
  [n, m] = size (KP.A);
  [q, r] = size (KP.B);
  if (n == m && q == r) # A and B are both square
    retval = kronprod (inv (KP.A), inv (KP.B));
  elseif (n*q == m*r) # kron (A, B) is square
    ## We use the SVD to compute the inverse.
    ## XXX: Should we use 'eig' instead?
    [U, S, V] = svd (KP);
    retval = U * inv (S) * V';
  else
    error ("inv: argument must be a square matrix");
  endif
endfunction
