function retval = mldivide (M1, M2)
  M1_is_KP = isa (M1, "kronprod");
  M2_is_KP = isa (M2, "kronprod");
  
  if (M1_is_KP && M2_is_KP) # Left division of Kronecker Products
    error ("mldividide: this part not yet implemented as I'm lazy...");

  elseif (M1_is_KP) # Left division of Kronecker Product and Matrix
    ## XXX: Does this give the same minimum-norm solution as when using
    ## XXX:   full (M1) \ M2
    ## XXX: ? It is the same when M1 is invertible.
    retval = zeros (columns (M1), columns (M2));
    for n = 1:columns (M2)
      M = reshape (M2 (:, n), [rows(M1.B), rows(M1.A)]);
      retval (:, n) = vec ((M1.A \ (M1.B \ M)')');
    endfor

  elseif (M2_is_KP) # Left division of Matrix and Kronecker Product
    error ("mldividide: this part not yet implemented as I'm lazy...");
      
  else
    error ("mldivide: internal error for 'kronprod'");
  endif
endfunction
