function [U, S, V] = svd (KP)
  if (nargout <= 1)
    ## Only singular values were requested
    S_A = svd (KP.A);
    S_B = svd (KP.B);
    U = kronprod (S_A, S_B);
  elseif (nargout == 3)
    ## The full SVD was requested
    [U_A, S_A, V_A] = svd (KP.A);
    [U_B, S_B, V_B] = svd (KP.B);
    U = kronprod (U_A, U_B);
    S = kronprod (S_A, S_B);
    V = kronprod (V_A, V_B);
  else
    print_usage ();
  endif
endfunction
